<?php
/*************************************************************************
file: modanalyzer.php by William (Rick) Bisbee.
Analyze all .cfg files in current folder for conflicts.
version 10.1.0.2, revised 12/03/2014
*************************************************************************/
$debug = false;
include 'begin.php';
include 'adminlib.php';
$textpart = "mods";
include 'getlang.php';
include "$mylanguage/admintext.php";
//tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
$admin_login = 1;
include 'checklogin.php';
include 'version.php';
$admvers='TNG10 V2.0 ';
$modspath .= '/';
$modfolder = 'tools/';

if( !empty( $debug ) ) {
   error_reporting( E_ALL );
   ini_set( 'display_errors', 'on' );
   ini_set( 'error_log', 'mm_error.log' );
}

define( 'YES', "1" );
define( 'NO', "0" );

// temporary: these can be set from any options file
include $subroot.'mmconfig.php';
//include 'classes/mod.class.config.php';


$helplang = findhelp("modhandler_help.php");

/*************************************************************************
Set Up for Admin Mod Header
**************************************************************************/
$flags['tabs'] = $tngconfig['tabs'];
$flags['modmgr'] = true;
tng_adminheader( $admtext['modmgr'], $flags );

$min_width = $sitever == 'mobile' ? '0' : '640px';
echo "
<style type='text/css'>
body {
   margin:0;
   overflow-y: scroll;
   min-width:$min_width;
}
</style>";

$parts = explode( ".", $tng_version );		// added to determine TNG vNN for
$tngmodver = "{$admtext['tngmods']} v{$parts[0]}";	// Mods for TNG vNN text display
$tngmodurl = "Mods_for_TNG_v{$parts[0]}";	// Mods for TNG vNN URL
$modtabs[0] = array(1,"admin_modhandler.php", $admtext['modlist'],"modlist");
$modtabs[1] = array(1,"admin_showmodslog.php",$admtext['viewlog'],"viewlog");
$modtabs[2] = array(1,"admin_modoptions.php",$admtext['options'],"options");
if ( $options['show_analyzer'] == YES) 
	$modtabs[3] = array(1,"admin_analyzemods.php",$admtext['analyzer'],"analyzer");


//	added links to innermenu to TNG Wiki articles
$innerhelp = "<a href=\"#\" onclick=\"return openHelp('$helplang/modhandler_help.php#analyze');\" class=\"lightlink\">{$admtext['help']}</a>";
$modsyntax = "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_Syntax\" target=\"_blank\" class=\"lightlink\">{$admtext['modsyntax']}</a>";
$modguidelines = "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Mod_Guidelines\" target=\"_blank\" class=\"lightlink\">{$admtext['modguidelines']}</a>";
$tngmods = "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Category:$tngmodurl\" target=\"_blank\" class=\"lightlink\">$tngmodver</a>";
$analyzer = "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng10beta.royandboucher.com/wiki/index.php?title=Using_the_Mod_Analyzer\" target=\"_blank\" class=\"lightlink\">{$admtext['analyzer']}</a>";
$innermenu = $innerhelp . $modsyntax . $modguidelines . $tngmods . $analyzer;

$menu = "<div class=\"mmmenuwrap\">";
$menu .= doMenu($modtabs,"analyzer",$innermenu);
$menu .= "</div>";

if(!isset($message)) $message = "";
$headline = displayHeadline($admtext['modmgr'],"img/modmgr_icon.gif",$menu,$message);
if( empty( $admtext['modguidelines'] ) ) $admtext['modguidelines'] = "Mod Guidelines";
/*************************************************************************
SHOW HEADER
*************************************************************************/
if( $options['fix_header'] == YES && $sitever != 'mobile' ) {
   $headclass = 'mmhead-fixed';
   $tableclass = 'm2table-fixed';
}
else {
   $headclass = 'mmhead-scroll';
   $tableclass = 'm2table-scroll';
}
//$bkgclass = 'tmpbkg'.$templatenum;
// only adjust css positioning for template 7 -- all others are standard
//if( $templatenum == 7 )
//   $tableclass = $tableclass.$templatenum;

echo "
</head>
<body background=\"img/background.gif\">
<div id=\"mmhead\" class=\"$headclass adminback\">
   $headline
</div><!--head-section-->";

echo "
<table id=\"m2table\" class=\"normal lightback $tableclass\">
<tr>
<td class=\"databack mmleftcol\">";

/*************************************************************************
DISPLAY INDEX OF MODIFIED FILES (LEFT SIDE)
**************************************************************************/
   echo "
<table class=\"normal tfixed\">
   <tr>
      <th class=\"fieldnameback fieldname\">{$admtext['filesel']}</th>
   <tr>";
   $modFiles = get_modfile_names();
   $targetFiles = get_targetfile_names( $modFiles );
   display_targetfiles( $targetFiles );
   echo "
   <tr><td>&nbsp;</td></tr>
</table><!--left-->
</td>";

/*************************************************************************
DISPLAY FILE MODIFICATIONS (RIGHT SIDE)
*************************************************************************/
   echo "
<td class=\"databack mmrightcol\">
<table class=\"normal tfixed\">
   <tr>
      <th class=\"fieldnameback fieldname\">{$admtext['potconf']}</th>
   </tr>";


if ($_GET && is_array ($_GET)) {
   if (!empty($mtarget)) {
      $file_hdr = str_replace( 'xxx', "<span class=\"mmhighlight\">$mtarget</span>", $admtext['filemod'] );
      echo "
   <tr>
      <td class=\"databack\">
         <h2>$file_hdr:</h2>
      </td>
   </tr>";

      $id = 1;
      $modfiles = get_modfile_names();
      foreach ($modfiles as $file) {
         $lines = file( $modspath.$file );
         $contents ='';
         foreach ($lines as $line) {
            $line = str_replace ('<', '&lt;', $line);
            $line = str_replace ('>', '&gt;', $line);
            $line = trim ($line);
            if (!empty ($line)) {
               $contents .= $line . '<br />';
            }
         }
         if( strpos( $contents, "%target:$mtarget%" ) || strpos( $contents, "%target: $mtarget" ) )  {
            echo "
   <tr>
      <td class=\"databack\">";
            display_section_locations( $file, $contents, $mtarget, "id$id" );
            $id++;
            echo "
      </td>
   </tr>";
         }
      }
   }
}
   echo "
</table><!--right-->
</td>
</tr>
</table><!--outter-->";
/*************************************************************************
JAVASCRIPT SECTION
*************************************************************************/
//$sitever = 'mobile'; //turns off jQuery positioning for testing
if( $sitever != 'mobile' && $options['adjust_headers'] ) {
   echo "
<script type=\"text/javascript\">
   jQuery(document).ready(function() {
      // set position of mm2table relative to mmhead
      jQuery('#m2table').position({
         my: 'left top',
         at: 'left bottom',
         of: jQuery('#mmhead'),
         collision: 'none'
      });
   });
</script>";
}
   echo "
<script type=\"text/javascript\">
function toggleSection(sectionName) {
   var section = document.getElementById(sectionName + 'div');
   var link = document.getElementById(sectionName + 'link');
   if(section.style.display == \"none\") {
      section.style.display = \"\";
      link.innerHTML = \"{$admtext['hide']}&nbsp;{$admtext['modifications']}\";
   }
   else {
      section.style.display = \"none\";
      link.innerHTML = \"{$admtext['show']}&nbsp;{$admtext['modifications']}\";
   }
   return false;
}
</script>";

   echo "
<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>
</body>
</html>";
exit;
/*************************************************************************
Functions
**************************************************************************/
function get_modfile_names () {
   global $modspath;

   $fileNames = array ();
   if ($handle = opendir($modspath)) {
      while (false !== ($file = readdir($handle))) {
         strtolower($file);
         if( pathinfo( $file, PATHINFO_EXTENSION ) == 'cfg' ) {
            $fileNames[]=$file;
         }
      }
      closedir($handle);
      sort ($fileNames);
   }
   return $fileNames;
}
function get_targetfile_names ($modFileNames) {
   global $modspath;

   $targets = array ();
   foreach ($modFileNames as $fileName) {
      $contents = file_get_contents($modspath.$fileName);
      $lines = explode("%target:", $contents);
      for ($i=1; $i < count($lines); $i++) {
         $element = substr($lines[$i], 0, (strpos($lines[$i], '%')));
         $element = trim( $element );
         if (strlen($element) > 0 && !in_array($element, $targets)) {
            $targets[] = $element;
         }
      }
   }
   sort ($targets);
   return ($targets);
}
function display_targetfiles ($targetFiles) {
   foreach ($targetFiles as $mtarget) {
      echo "
   <tr><td class=\"lightback databack mmrightalign\">
      <a class=\"mmlinks\" href=\"?mtarget=$mtarget\">$mtarget</a>
   </td></tr>";
   }
}
function display_section_locations( $modfile, $contentstr, $mtarget, $id ) {
   global $admtext;
   $sections = array_map( 'trim', explode( "%target:", $contentstr ) );
   echo "
      <span class=\"mmfilenmfont\">$modfile</span>&nbsp;&nbsp;
      <a href=\"#\" id=\"{$id}link\" onclick=\"return toggleSection('$id');\">
         {$admtext['show']}&nbsp;{$admtext['modifications']}
      </a><br />
      <div id=\"{$id}div\" style=\"display:none\">";
   for( $i=1; isset( $sections[$i] ); $i++ ) {
      $target_file = trim(preg_replace("#([^%]*)%.*#s", "\${1}", $sections[$i]));
      if( trim( $target_file ) == trim( $mtarget ) ) {
         $locations = array_map ('trim', explode ("%location:%", $sections[$i]));
         for ($j=1; isset($locations[$j]); $j++) {
            $locations[$j] = substr( $locations[$j], 0, strripos( $locations[$j], '%end:%' ) );
            $locations[$j] = str_replace ("%end:%", "</strong>%end:%", $locations[$j]);
            $locations[$j] .= "%end:%<br />";
            $locations[$j] = preg_replace("@((%location|%end|%trim|%insert|%replace)[^%]*%)@i", "<span class=\"mmkeyword\">$1</span>", $locations[$j]);
            echo "
         <span class=\"mmlochdr\">// Location $j</span><br />
         <span class=\"mmkeyword\">%location:%</span><strong>
         {$locations[$j]}";
         }
      }
   }
   echo "
      </div>";
}
 ?>