<?php
define( 'YES',      "1" );
define( 'EDITP',     5 );
define( 'UPDATEP',   6 );
define( 'RESTOREP',  7 );

$debug = false;
include("begin.php");
include("adminlib.php");
$textpart = "mods";
include("getlang.php");

include("$mylanguage/admintext.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password,$database_port,$database_socket) or exit;
$admin_login = 1;
include("checklogin.php");
include("version.php");
include("classes/version.php");
$thisfile = $_SERVER['PHP_SELF'];

if( !empty( $debug ) ) {
   error_reporting( E_ALL );
   ini_set( 'display_errors', 'on' );
   ini_set( 'error_log', 'mm_error.log' );
}
//include 'classes/mod.class.config.php';
include $subroot.'mmconfig.php';
$helplang = findhelp("modhandler_help.php");

$parts = explode( ".", $tng_version );		// added to determine TNG vNN for
$tngmodver = "{$admtext['tngmods']} v{$parts[0]}";	// Mods for TNG vNN text display
$tngmodurl = "Mods_for_TNG_v{$parts[0]}";	// Mods for TNG vNN URL

$modtabs[0] = array(1,"admin_modhandler.php",$admtext['modlist'],"modlist");
$modtabs[1] = array(1,"admin_showmodslog.php",$admtext['viewlog'],"viewlog");
$modtabs[2] = array(1,"admin_modoptions.php",$admtext['options'],"options");
if ( $options['show_analyzer'] == YES)
	$modtabs[3] = array(1,"admin_analyzemods.php",$admtext['analyzer'],"analyzer");

// inner menu help
$innermenu = "<a href=\"#\" onclick=\"return openHelp('$helplang/modhandler_help.php');\" class=\"lightlink\">{$admtext['help']}</a>";

// MM syntax
$innermenu .= "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_Syntax\" target=\"_blank\" class=\"lightlink\">{$admtext['modsyntax']}</a>";

// mod guidelines
$innermenu .= "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Mod_Guidelines\" target=\"_blank\" class=\"lightlink\">{$admtext['modguidelines']}</a>";

// mods for TNGv10
$innermenu .= "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Category:$tngmodurl\" target=\"_blank\" class=\"lightlink\">$tngmodver</a>";
$menu = "<div class=\"mmmenuwrap\">";
$menu .= doMenu($modtabs,"modlist",$innermenu);
$menu .= "</div>";
if(!isset($message)) $message = "";
$headline = displayHeadline($admtext['modmgr'].' - '.ucwords($admtext['edparams']),"img/modmgr_icon.gif",$menu,$message);
$first_menu=TRUE;

$cfgfolder = rtrim( $rootpath, "/" ).'/'.trim( $modspath, "/" ).'/';
$mhuser = isset( $_SESSION['currentuserdesc'] ) ? $_SESSION['currentuser'] : "";

$fpaths = array (
   'rootpath'  => $rootpath,
   'subroot'   => $subroot,
   'modspath'  => $modspath,
   'extspath'  => $extspath
);

$objinits = array (
   'fpaths'       => $fpaths,
   'time_offset'  => $time_offset,
   'sitever'      => $sitever,
   'currentuserdesc' => $mhuser,
   'admtext'      => $admtext,
   'templatenum'  => $templatenum
);
/*************************************************************************
PROCESS POSTED FORM DATA
*************************************************************************/
if( !empty( $_POST ) ) {
   foreach( $_POST as $key => $value ) {
      ${$key} = $value;
   }
   if( $submit == "pUpdate" ) {
      //echo __FILE__,' ',__LINE__;print_r($_POST);exit;
      include_once 'classes/modeditor.class.php';
      $oEdit = new modeditor( $objinits );
      $oEdit->set_options( $options );
      if( $oEdit->update_parameter( $param ) ) {
         $action = EDITP;
         $cfgpath = $param['cfg'];
      }
      else {
         header("Location:admin_showmodslog.php");
         exit;
      }
   }
   elseif( $submit == "pRestore" ) {
      include_once 'classes/modeditor.class.php';
      $oEdit = new modeditor( $objinits );
      $oEdit->set_options( $options );
      if( $oEdit->restore_parameter( $param ) ) {
         $action = EDITP;
         $cfgpath = $param['cfg'];
      }
      else {
         header("Location:admin_showmodslog.php");
         exit;
      }
   }
   elseif( $submit == "pCancel" ) {
      header("Location:admin_modhandler.php");
   }
}
/*************************************************************************
PROCESS QUERY LINE ARGS
*************************************************************************/
elseif( !empty( $_GET ) ) {
   //echo __FILE__,' ',__LINE__,'<br />';print_r( $_GET );exit;
   foreach( $_GET as $key => $value ) {
      ${$key} = $value;
   }
   if( isset( $a ) ) {
      $action = isset( $a ) ? $a : '';
      $cfgfile = isset( $m ) ? $m : '';
      $cfgpath = isset( $m ) ? $cfgfolder.$m : '';
   }
}

/*************************************************************************
SHOW PAGE HEADER
*************************************************************************/
$flags['tabs'] = $tngconfig['tabs'];
$flags['modmgr'] = true;
tng_adminheader( $admtext['modmgr'], $flags );

//include 'classes/tempstyle.php';
$min_width = $sitever == 'mobile' ? '0' : '640px';
echo "
<style type='text/css'>
body {
   margin:0;
   overflow-y: scroll;
   min-width:$min_width;
}
</style>";

if( $options['fix_header'] == YES && $sitever != 'mobile' ) {
   $headclass = 'mmhead-fixed';
   $tableclass = 'm2table-fixed';
}
else {
   $headclass = 'mmhead-scroll';
   $tableclass = 'm2table-scroll';
}
//$bkgclass = 'tmpbkg'.$templatenum;
// only adjust css positioning for template 7 -- all others are standard
//if( $templatenum == 7 )
//   $tableclass = $tableclass.$templatenum;

echo "
</head>
<body background=\"img/background.gif\">
<div id=\"mmhead\" class=\"$headclass adminback\">
   $headline
</div><!--head-section-->";
/*************************************************************************
SHOW EDIT FORM
*************************************************************************/
if( !empty( $action ) && $action == EDITP ) {
   if( !class_exists( "modeditor" ) ) {
      include_once 'classes/modeditor.class.php';
      $oEdit = new modeditor( $objinits );
   }
   $oEdit->set_options( $options );
   if( !$oEdit->show_editor( $cfgpath ) ) {
      ?>
      <script>
         window.location.href="admin_showmodslog.php";
      </script>
      <?php
   };
}
/*************************************************************************
SHOW EDIT FORM
*************************************************************************/
if( $sitever != 'mobile' && $options['adjust_headers'] ) {
   echo "
<script type=\"text/javascript\">
   window.scroll(0,0);
   jQuery(document).ready(function() {
      // set position of the title bar (tbar) relative to mmhead
      jQuery('#tbar').position({
         my: 'left top',
         at: 'left bottom',
         of: jQuery('#mmhead'),
         collision: 'none'
      });
   // set position of m3table table relative to title bar (tbar)
   jQuery('#m3table').position({
      my: 'left top',
      at: 'left bottom',
      of: jQuery('#tbar'),
      collision: 'none'
   });
</script>";
}

echo "
</body>
</html>";
exit;
?>