<?php
/*
   Mod Manager Generation III.
      Brian McFadyen: Original concept
      Rick Bisbee: Main script, Mod List, Analyzer, OOP class library
      Ken Roy: View Log, Options, Test Manager
      Robin Richmond: View Log
      Jeff Robison: Affected Files Display
*/

$debug = false;

include("begin.php");
include("adminlib.php");
$textpart = "mods";
include("getlang.php");

include("$mylanguage/admintext.php");

//tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
$admin_login = 1;
include("checklogin.php");
include("version.php");
include("classes/version.php");

$thisfile = $_SERVER['PHP_SELF'];

if( !empty( $debug ) ) {
   error_reporting( E_ALL );
   ini_set( 'display_errors', 'on' );
   ini_set( 'error_log', 'mm_error.log' );
}
define( 'NAMECOL',   1 );
define( 'FILECOL',   0 );
define( 'YES',      "1" );
define( 'NO',       "0" );
define( 'ON_ERROR',  0 );
define( 'ON_ALL',    1 );

define( 'INSTALL',   1 );
define( 'REMOVE',    2 );
define( 'DELETE',    3 );
define( 'CLEANUP',   4 );
define( 'EDITP',     5 );
define( 'UPDATEP',   6 );
define( 'RESTOREP',  7 );

// temporary: these can be set from any options file
//include 'classes/mod.class.config.php';
include $subroot.'mmconfig.php';

// can we create files and write to our log in the tng root folder?
$message = '';
if( !is_writable( $rootpath ) )
$message .= "{$admtext['checkwrite']} {$admtext['cantwrite']} $rootpath ";
if( isset($_SESSION['err_msg'] ) ) {
	$message = $_SESSION['err_msg'];
	unset( $_SESSION['err_msg'] );
}
if( !empty( $message ) ) {
   $message = "<span class=\"msgerror\">$message</span>";
}

// column sort selection
if( isset( $_GET['sort'] ) ) {
   $_SESSION['sortby'] = $_GET['sort'];
}
if( isset( $_SESSION['sortby'] ) )
   $options['sortby'] = $_SESSION['sortby'];

if (!isset($options['show_analyzer'])) $options['show_analyzer'] = "0";	// Default to not show the Analyzer tab
if (!isset($options['compress_log'])) $options['compress_log'] = "0";	// Default to not compress log
$helplang = findhelp("modhandler_help.php");

//$flags['tabs'] = $tngconfig['tabs'];

//tng_adminheader( $admtext['modmgr'], $flags );

$parts = explode( ".", $tng_version );		// added to determine TNG vNN for
$tngmodver = "{$admtext['tngmods']} v{$parts[0]}";	// Mods for TNG vNN text display
$tngmodurl = "Mods_for_TNG_v{$parts[0]}";	// Mods for TNG vNN URL

$modtabs[0] = array(1, $thisfile, $admtext['modlist'],"modlist");
$modtabs[1] = array(1,"admin_showmodslog.php",$admtext['viewlog'],"viewlog");
$modtabs[2] = array(1,"admin_modoptions.php",$admtext['options'],"options");
if ( $options['show_analyzer'] == YES)
	$modtabs[3] = array(1,"admin_analyzemods.php",$admtext['analyzer'],"analyzer");

// inner menu help
$innermenu = "<a href=\"#\" onclick=\"return openHelp('$helplang/modhandler_help.php');\" class=\"lightlink\">{$admtext['help']}</a>";

// expand & collapse all
$innermenu .= " &nbsp;|&nbsp; <a href=\"#\" class=\"lightlink\" id=\"expandall\"> {$text['expandall']}</a>";
$innermenu .= " &nbsp;|&nbsp; <a href=\"#\" class=\"lightlink\" id=\"collapseall\">{$text['collapseall']}</a>";

// MM syntax
$innermenu .= "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_Syntax\" target=\"_blank\" class=\"lightlink\">{$admtext['modsyntax']}</a>";

// mod guidelines
$innermenu .= "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Mod_Guidelines\" target=\"_blank\" class=\"lightlink\">{$admtext['modguidelines']}</a>";

// mods for TNGv10
$innermenu .= "&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"http://tng.lythgoes.net/wiki/index.php?title=Category:$tngmodurl\" target=\"_blank\" class=\"lightlink\">$tngmodver</a>";

$menu = "<div class=\"mmmenuwrap\">";
$menu .= doMenu($modtabs,"modlist",$innermenu);
$menu .= "</div>";

if(!isset($message)) $message = "";
$headline = displayHeadline($admtext['modmgr'],"img/modmgr_icon.gif",$menu,$message);

$first_menu=TRUE;

$cfgfolder = rtrim( $rootpath, "/" ).'/'.trim( $modspath, "/" ).'/';

$mhuser = isset( $_SESSION['currentuserdesc'] ) ? $_SESSION['currentuser'] : "";

$fpaths = array (
   'rootpath'  => $rootpath,
   'subroot'   => $subroot,
   'modspath'  => $modspath,
   'extspath'  => $extspath
);

$objinits = array (
   'fpaths'       => $fpaths,
   'time_offset'  => $time_offset,
   'sitever'      => $sitever,
   'currentuserdesc' => $mhuser,
   'admtext'      => $admtext,
   'templatenum'  => $templatenum
);
/*************************************************************************
PROCESS POSTED FORM DATA (BULK REQUESTS)
*************************************************************************/
if( !empty( $_POST ) ) {
   //echo __FILE__,' ',__LINE__,'<br />';print_r( $_POST );exit;
   foreach( $_POST as $key => $value ) {
      ${$key} = $value;
   }
   if( !empty( $submit ) ) {
      if( $submit != 'Go' ) {
         unset( $filter );
      }
      if( !empty( $mods ) ) {
         foreach( $mods as $mod ) {
            if( isset( $mod['selected'] ) ) {
               $modlist[] = $cfgfolder.$mod['file'];
            }
         }
      }
      if( $submit == "installall" ) {
         //echo __FILE__,' ',__LINE__,'<br />';print_r( $modlist);exit;
         include_once 'classes/modinstaller.class.php';
         $oInstaller = new modinstaller( $objinits );
         $oInstaller->set_options( $options );
         if(!$oInstaller->batch_install( $modlist ) || $options['redirect2log'] == ON_ALL ) {
            header("Location:admin_showmodslog.php");
            exit;
         }
		 else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
      elseif( $submit == "removeall" ) {
         //echo __FILE__,' ',__LINE__;print_r($modlist);exit;
         include_once 'classes/modremover.class.php';
         $oRemover = new modremover( $objinits );
         $oRemover->set_options( $options );
         if( !$oRemover->batch_remove( $modlist ) || $options['redirect2log'] == ON_ALL ) {
            header("Location:admin_showmodslog.php");
            exit;
         }
 		 else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
      elseif( $submit == "cleanupall" ) {
         include_once 'classes/modremover.class.php';
         $oRemover = new modremover( $objinits);
         $oRemover->set_options( $options );
         if( !$oRemover->batch_remove( $modlist ) || $options['redirect2log'] == ON_ALL ) {
            header("Location:admin_showmodslog.php");
            exit;
         }
		 else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
      elseif( $submit == "deleteall" ) {
         //echo __FILE__,' ',__LINE__;print_r($_POST);exit;
         include_once 'classes/moddeleter.class.php';
         $oDeleter = new moddeleter( $objinits);
         $oDeleter->set_options( $options );
         if( !$oDeleter->batch_delete( $modlist ) || $options['redirect2log'] == ON_ALL ) {
            header( "Location:admin_showmodslog.php");
            exit;
         }
		 else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
   }
}
/*************************************************************************
PROCESS QUERY LINE ARGS (SINGLE MOD REQUESTS)
*************************************************************************/
elseif( !empty( $_GET ) ) {
   //echo __FILE__,' ',__LINE__,'<br />';print_r( $_GET );exit;
   foreach( $_GET as $key => $value ) {
      ${$key} = $value;
   }
   if( isset( $a ) ) {
      $action = isset( $a ) ? $a : '';
      $cfgpath = isset( $m ) ? $cfgfolder.$m : '';

      if( $action == INSTALL ) {
         //echo __FILE__,' ',__LINE__;print_r( $_GET );exit;
         include_once 'classes/modinstaller.class.php';
         $obj = new modinstaller( $objinits );
         $obj->set_options( $options );
         if( !$obj->install( $cfgpath ) || $options['redirect2log'] == ON_ALL ) {
            // if fails to install, show log
            header( "Location:admin_showmodslog.php");
            exit;
         }
         else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
      elseif( $action == REMOVE ) {
         //echo __FILE__,' ',__LINE__," $cfgpath";exit;
         include_once 'classes/modremover.class.php';
         $obj = new modremover( $objinits );
         $obj->set_options( $options );
         if( !$obj->remove( $cfgpath ) || $options['redirect2log'] == ON_ALL ) {
            // if fails to remove mod, show log
            header( "Location:admin_showmodslog.php");
            exit;
         }
         else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
      elseif( $action == DELETE ) {
         $error = false;
         include_once 'classes/moddeleter.class.php';
         $obj = new moddeleter( $objinits );
         $obj->set_options( $options );
         if( !$obj->delete_mod( $cfgpath ) || $options['redirect2log'] == ON_ALL ) {
            header( "Location:admin_showmodslog.php");
            exit;
         }
         else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
      elseif( $action == CLEANUP ) {
         include_once 'classes/modremover.class.php';
         $obj = new modremover( $objinits );
         $obj->set_options( $options );
         $obj->classID = "cleaner";
         if( !$obj->remove( $cfgpath ) || $options['redirect2log'] == ON_ALL ) {
            // if fails to remove installed components show log
            header( "Location:admin_showmodslog.php");
            exit;
         }
         else {
            header( "Location:admin_modhandler.php" );
            exit;
         }
      }
   }
}

// SET FILTER
// RULES:
//    $filter is only set by the GO button to change filters
//    $_SESSION['filter'] is only set/unset by the Return to (filtered) Page checkbox
$fbox_checked = false;
if( !isset( $filter ) ) { // not asking for filter change
   if( isset( $_SESSION['filter'] ) ) {
      $filter = $_SESSION['filter'];
      $fbox_checked = true;
   }
   else {
      $filter = 0;
   }
}
else {
   // filter eas set from drop down -- starting over with clean filter checkbox
   if( isset( $_SESSION['filter'] ) )
      unset( $_SESSION['filter'] );
}

// current sort order
if( isset( $_GET['sort'] ) )
   $_SESSION['sortby'] = $_GET['sort'];
if( isset( $_SESSION['sortby'] ) )
   $options['sortby'] = $_SESSION['sortby'];

/*************************************************************************
DISPLAY MAIN SCREEN (MOD LIST)
*************************************************************************/
$flags['tabs'] = $tngconfig['tabs'];
$flags['modmgr'] = true;
tng_adminheader( $admtext['modmgr'], $flags );

$min_width = $sitever == 'mobile' ? '0' : '640px';
echo "
<style type='text/css'>
body {
   margin:0;
   overflow-y: scroll;
   min-width:$min_width;
}
</style>";
$headclass = $options['fix_header'] == YES && $sitever != 'mobile' ? 'mmhead-fixed' : 'mmhead-scroll';
//$bkgclass = 'tmpbkg'.$templatenum;

echo "
<script type=\"text/javascript\" src=\"js/admin.js\"></script>
</head>
<body background=\"img/background.gif\">
<div id=\"mmhead\" class=\"$headclass adminback\">
   $headline
</div><!--head-section-->";

// add this style to mmhead-scroll if necessary
//<div id=\"notfixedpage\" class=\"lightback\">


// test parser
/*
include_once 'classes/modparser.class.php';
$oParse = new modparser($objinits);
//$oParse->parse( 'mods/personal_table_maintenance_v9.1.2.3.cfg' );
//$oParse->parse('mods/living_color_v10.0.2.10.cfg');
//$oParse->parse('mods/customized_logs_v10.0.0.2.cfg');
//$oParse->parse( 'mods/censusplus_v10.0.0.0b.cfg' );
$oParse->parse( 'mods/geocode_assist_v10.1.0.1.cfg' );
echo $oParse->description,'<br />';
print_r( $oParse->warnings );
print_r( $oParse->parse_errors );
print_r( $oParse->tags );
exit;
*/
   //echo __FILE__,' ',__LINE__;print_r( $options );exit;
   include 'classes/modlister.class.php';
   $oModlist = new modlister( $objinits );
   $oModlist->filter = $filter;
   $oModlist->fbox_checked = $fbox_checked;
   $oModlist->templatenum = $templatenum;
   $oModlist->set_options( $options );
   $oModlist->list_mods();

/*************************************************************************
JQUERY/JAVASCRIPT FUNCTIONS
*************************************************************************/
echo "
<script type=\"text/javascript\">
jQuery(document).ready(function() {
";

//$sitever = 'mobile'; //turns off jQuery positioning for testing
if( $sitever != 'mobile' && $options['adjust_headers'] ) {
   echo "
   window.scroll(0,0);

   // set position of status bar relative to #mmhead (jQuery UI)
   jQuery('#fbar').position({
      my: 'left top',
      at: 'left bottom',
      of: jQuery('#mmhead'),
      collision: 'none'
   });

   // set position of listing table relative to filter bar (jQuery UI)
   jQuery('#mmgrid').position({
      my: 'left top',
      at: 'left bottom',
      of: jQuery('#fbar'),
      collision: 'none'
   });
";
}
   echo"
   // toggle mod status from other fields
	jQuery('.flink').click(function() {
      var flinkID = jQuery(this).attr('id');
      var linknum = flinkID.match(/\d+/);
      var linkID = 'link'+linknum;
      toggleStatus(linkID);
	});

   // toggle mod status from status field header
	jQuery('.modlink').click(function() {
		var linkID = jQuery(this).attr('id');
      toggleStatus(linkID);
	});

   function toggleStatus( linkID ) {
      var divID = linkID + 'div';
		if( jQuery('#' + linkID).hasClass('closed') ) {
         jQuery('#' + linkID).addClass('opened').removeClass('closed');
		   jQuery('#' + divID).show();
      }
		else {
         jQuery('#' + linkID).addClass('closed').removeClass('opened');
			jQuery('#' + divID).hide();
      }
   }

   // close all
   jQuery('#collapseall').click(function() {
      jQuery('.modlink').addClass('closed').removeClass('opened');
      jQuery('.moddiv').hide();
   });

   // open all
   jQuery('#expandall').click(function() {
      jQuery('.modlink').addClass('opened').removeClass('closed');
      jQuery('.moddiv').show();
   });

   jQuery('#selectAll').click(function(){
      jQuery('input.sbox').prop('checked',true);
   });

   jQuery('#clearAll').click(function(){
      jQuery('input.sbox').prop('checked',false);
   });

   jQuery('#btnDelete').click(function(){
      if(jQuery('input.sbox:checkbox:checked').length>0 ) {
         return confirm(\"{$admtext['nomodundo']}\");
      }
      else {
         alert(\"{$admtext['noselected']}\" );
         return false;
      }
   });
   jQuery('#btnInstall, #btnRemove, #btnClean').click(function(){
      if( jQuery('input.sbox:checkbox:checked').length>0 ) {
         return true;
      }
      else {
         alert(\"{$admtext['noselected']}\" );
         return false;
      }
   });
   jQuery('#stayon').change(function() {
      if(this.checked) {
         jQuery.post('classes/ajax_filter.php', {filter:\"$oModlist->filter\"});
         }
      else {
         jQuery.post('classes/ajax_filter.php', {filter:\"0\"});
      }
   });
});

</script>";

echo "
<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version ($mm_version)</span></div>
</body>
</html>";
?>
