<?php

/*
   This class handles mod deletions
   It also provide logging services.

   Data:

   Methods:
      public function delete_mod( $cfgpath );
      public function batch_delete( $cfgpathlist );
*/

include_once 'classes/modparser.class.php';

class moddeleter extends modbase {
   protected $classID = "deleter";

   function __construct( $objinits ) {
      // pass arguments thru to base class
      parent::__construct( $objinits );
	}

   public function delete_mod( $cfgpath ) {
      $admtext = $this->admtext;
      // parse file to get logging info
      $this->cfgpath = $cfgpath;
      $this->cfgfile = $cfgfile = pathinfo( $cfgpath, PATHINFO_BASENAME );
      $contents = file_get_contents( $cfgpath, null, null, 0, 1024 );

      if( preg_match( "#%name:([^%]+)%#", $contents, $matches ) ) {
         $this->modname = $matches[1];
      }
      else {
         $this->modname = "no name";
      }
      $this->new_logevent( "{$admtext['deleting']} <strong>$cfgpath</strong>" );
      $this->new_logevent( "{$this->admtext['deleting']} <strong>$cfgpath</strong>" );
      if( @!unlink( $cfgpath ) ) {
         $msg = "<span class=\"hilighterr msgbold\">{$this->admtext['cantdel']}</span>";
         $this->mod_status = self::CANTDEL;
         $success = false;
      }
      else {
         $msg = "<span class=\"msgapproved\">{$this->admtext['filedel']}</span>";
         $this->mod_status = self::FILEDEL;
         $success = true;
      }
      $this->add_logevent( $msg );
      $this->write_eventlog();
      return $success;
   }
   public function batch_delete( $cfgpathlist ) {
      foreach( $cfgpathlist as $cfgpath ) {
         if( !$this->delete_mod( $cfgpath ) ) {
            $this->batch_error = true;
         };
      }
      return !$this->batch_error;
   }
}
?>