<?php
include("../../helplib.php");
echo help_header("Help: Mod Manager");
?>

<body class="helpbody">
<a name="top"></a>
<table width="100%" border="0" cellpadding="10" cellspacing="2" class="tblback normal">
<tr class="fieldnameback">
	<td class="tngshadow">
		<p style="float:right; text-align:right" class="smaller menu">
			<a href="http://tng.community" target="_blank" class="lightlink">TNG Forum</a> &nbsp; | &nbsp;
			<a href="http://tng.lythgoes.net/wiki" target="_blank" class="lightlink">TNG Wiki</a><br />
			<a href="backuprestore_help.php" class="lightlink">&laquo; Help: Utilities</a> &nbsp; | &nbsp;
			<a href="index_help.php" class="lightlink">Help: Getting Started &raquo;</a>
		</p>
		<span class="largeheader">Help: Mod Manager</span>
		<p class="smaller menu">
			<a href="#overview" class="lightlink">Overview</a> &nbsp; | &nbsp;
			<a href="#operation" class="lightlink">Operation</a> &nbsp; | &nbsp;
			<a href="#status" class="lightlink">Status</a> &nbsp; | &nbsp;
			<a href="#syntax" class="lightlink">Mod Syntax</a> &nbsp; | &nbsp;
			<a href="#files" class="lightlink">Config Files</a> &nbsp; | &nbsp;
			<a href="#batch" class="lightlink">Batch Operations</a> &nbsp; | &nbsp;
			<a href="#options" class="lightlink">Options</a> &nbsp; | &nbsp;
			<a href="#analyze" class="lightlink">Analyzer</a>
		</p>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<a name="overview"><p class="subheadbold">Overview</p></a>

		<p>The TNG 10.1 version of the Mod Manager is based on the Mod Manager originally developed by Brian McFadyen and updated by Sean Schwoere to work with the Joomla TNG Component.  The Mod Manager combines the Mod List and Batch Updates provided in TNG 10.0.3 and is intended to provide a more integrated way to install, remove and manage modifications to the TNG software package that have been coded to work with this manager.</p>
		<p>The new Mod Manager provides a single line summary of the mod status which can be expanded to view the complete Description and errors when applicable.  The Affected Files List can be displayed by hovering over the + plus sign in the Files column.  You can also use the <stron>Expand All</strong> inner menu to expand all entries to show the status like the old Mod Manager used to do.  The Expand All option is helpful when filtering the list by <strong>Partially Installed</strong> or <strong>Cannot Install</strong> so you can see what the errors are.</p> 
		<p>The Mod Manager is connected into the TNG Administrative page for easy access. The Mod Manager adds the following folders to TNG:
		<ul>
			<li><strong>mods</strong> to contain the Mod configuration files and associated Mod support files</li>
			<li><strong>extensions</strong> to contain some of the mod extensions that are installed by other Mod Manager config files</li>
			<li><strong>classes</strong> which contain the Object Orient Progamming classes that were split and enhanced from the previous managemods.class.php created by Sean Schwoere from Brian's original Mod Manager code.</li>
		</ul></p>
		<p>The <strong>Mod List</strong> tab now combines the previous Mod List and Batch Updates that was added by Rick Bisbee in TNG 10.0.3 to provide the capability to execute the same action against multiple mods. The Description and extended status can be displayed by clicking the right arrow in the Status column or anywhere on the line. Hovering over the line will high light the line to make it easier to select the status to expand.  Hovering over the + plus sign in the Files column will display the Affected Files list, that is the files modified, created, and copied by this mod.</p>
		<p>The <strong>View Log</strong> tab was added by Ken Roy in TNG 10.0.3 to display the Mod Manager Log which is now split from the Admin Log.  The Mod Manager log is the reformated log from the Mod Manager created by Rick Bisbee in TNG 10.03 for easier readability of the actions.  The messages were also greatly simplified.</p>
		<p>The <strong>Options</strong> tab is a modification of the one added by Ken Roy in TNG 10.0.3 to allow changing some of the execution behavior of the Mod Manager.</p>
		<p>The <strong>Analyzer</strong> tab is an optional tab that can be enabled in the Options screen that allows you to view which mods change a specific TNG php script.</p> 
<p>Additional information can be found in the <a href="http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager" target="_blank">Mod Manager</a> article and in the <a href="http://tng.lythgoes.net/wiki/index.php?title=Category:TNG_Mod_Manager" target="_blank">TNG Mod Manager</a> category of articles on the TNG Wiki.

	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="operation"><p class="subheadbold">Operation</p></a>

		<p>The Mod Manager examines the mods folder and reads each <strong>cfg</strong> file that it finds. The <strong>cfg</strong> files are directive files that describe the mod, the files and locations to be modified, and the code that is used in the modification.
		<p>The Mod Manager checks the following:
			<ul>
				<li>ensures the user is logged in
				<li>examines each code location and change
					<ul>
						<li>ensures the location can be found</li>
						<li>ensures the target location is unique</li>
						<li>identifies whether the target location has already been installed</li>
					</ul>
			<li>identifies new files to be created. If the new file already exists, it examines the version level</li>
			</ul></p>

	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="status"><p class="subheadbold">Status</p></a>
			<p>The Mod Manager returns the following status:
			<ul>
			<li><strong>Ok to Install</strong> if the mod is not yet installed and the target locations can be identified, then the <strong>Install</strong> button is displayed</li>
			<li><strong>Installed</strong> if the mod is completely installed, the option to <strong>Uninstall</strong> the Mod is presented and the option to <strong>Edit</strong> parameters if any exist.  Mods with edit parameters are identified by[Option] after the Installed status.</li>
			<li><strong>Partially installed</strong> if the mod is partially installed, the <strong>Cleanup</strong> button is provided. A Clean up operation will attempt to remove any inserted code, restore and replaced code, and remove any created or copied files.</li>
			<li><strong>Cannot Install</strong> if the mod <strong>cannot</strong> be installed. You will need to expand the Status to get more detailed messages as to why the mod cannot be installed.</li>
			</ul>
		<p>For examples of the Mod Manager Status screens and how to interpret the various statuses, see <a href="http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_-_Interpreting_Status" target="_blank">Mod Manager - Interpreting Status</a></p>

</p>

	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="syntax"><p class="subheadbold">Mod Syntax</p></a>
			<p>The Mod Manager syntax basically includes:
			<p><strong>Header section</strong> that includes</p>
				<ul><li>Name - the name of the mod, wiki article and file name</li>
				<li>Version - the version of the mod, where the first 3 period places represents the lowest TNG version to which the mod applies</li>
				<li>Description - provides a brief description of the mod, the Mod Developer's name, and a URL link to the TNG Wiki article for the mod.</li>
				</ul>
			</p>
			<p><strong>Target sections</strong> that specify the file that is the target of the change and includes the following directives</p>
			<ul><li>Location - that specifies the code location to be changed</li>
			<li>Action keyword - that specifies whether to replace or insert code before or after the location</li>
			</ul>
			</p>
			<p><strong>New File directives</strong> that create the file when the mod is installed</p>
			<p><strong>Copy File directives</strong> that copy the specified file to the TNG root (%copyfile) or to a subfolder (%copyfile2)</p>
		<p>For detailed information on the Mod Manager Syntax, see <a href="http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_Syntax" target="_blank">Mod Manager Syntax</a></p>



	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="files"><p class="subheadbold">Config Files</p></a>

		<span class="optionhead">Installing Mods</span>
		<p>The TNG Wiki provides information on <a href="http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_-_Installing_Config_Files" target="_blank">Installing Config Files</a> to install the TNG mods.</p>
		
		<span class="optionhead">Interpreting Status</span>
		<p>The TNG Wiki provides information on <a href="http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_-_Interpreting_Status" target="_blank">Interpreting Status</a>.</p>
		
		<span class="optionhead">Config File Syntax</span>
		<p>The TNG Wiki provides information on the <a href="http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_Syntax" target="_blank">Mod Manager Syntax</a>.</p>
		
		<span class="optionhead">Creating Config Files</span>
		<p>The TNG Wiki provides information for the mod developers on the <a href="http://tng.lythgoes.net/wiki/index.php?title=Mod_Manager_-_Creating_Config_Files" target="_blank">Creating Config Files</a>.</p>
	</td>
</tr>

<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="batch"><p class="subheadbold">Batch Operations</p></a>

		<p>The Batch Operations function introduced in TNG 10.0.3 as a Batch Updates tab is now combined in the Mod List and allows specific actions on multiple mods using the Select Filter.  You must choose from the status filter list and click <strong>Go</strong> to display the available controls for the specific status selected.  <strong>Delete</strong> is only available for the Clean Up status if you enable the Option, which we recommend that you leave as No, except for when you need to delete multiple mods in the Partially Installed status, such as a prior version of the same mod. Likewise there is a Delete Installed mods option that will allow deleting installed mods without removing them.  This ootion was added to allow deleting previous versions of the same mod, if you forgot to delete them before installing the new version.  Here again it is recommend that you leave the option as No and just enable it when needed.</p>
		<p><strong><font color="red">Caution:You should only use Batch Operations if you have a good backup of your website and can quickly restore it if the batch operations renders your site inoperable, which can easily happen if you do not delete previous versions of the mods.</font></strong></p>
		<p>The Select Filter options are:
			<ul>
				<li><strong>All</strong> - displays all a list of all the .cfg files in the mods folder.  When you select a specific status then Action buttons will become available
				<li><strong>Ok to Install</strong> - displays a list of all the mods that can be</li>
					<ul>
						<li>Installed based on your selections and clicking the <strong>Install</strong> button</li>
						<li>Deleted from your mods folder based on your selections and clicking the <strong>Delete</strong> button</li>
					</ul>
				<li><strong>Installed</strong> - displays a list of all the mods that are currently installed that can be</li>
					<ul>
						<li>Removed based on your selections and clicking the <strong>Remove</strong> button</li>
					</ul>
				<li><strong>Partially Installed</strong> - displays a list of all the mods that are partially installed and must be</li>
					<ul>
						<li>Cleaned up based on your selections and clicking the <strong>Clean Up Selected</strong> button</li>
					</ul>
				<li><strong>Cannot Install</strong> - displays a list of all the mods that cannot be installed, either due to Bad Targets or Missing files, that can be</li>
					<ul>
						<li>Deleted from your mods folder based on your selections and clicking the <strong>Delete Selected</strong> button</li>
					</ul>
	</td>
</tr>

<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="options"><p class="subheadbold">Options</p></a>

		<p>The Options allows you to specify some of the Mod Manager behavior for the 
		<p><strong>Mod Manager Log Options</strong> 
			<ul>
				<li><strong>Log File Name</strong> - allows you to specify the file name to be used for the Mod Manager log.  The default is <strong>modmgrlog.txt</strong>.</li>
				<li><strong>Max number of Transactions</strong> - allows you to specify how many log transactions to keep in the log. The default is <strong>200</strong> transactions.</li>
				<li><strong>Collapse Log display</strong> - allows you to specify if you want the View Log displayed in a collapsed or expanded format initially.  The default is <strong>Yes</strong> but can be changed to <strong>No</strong> to display the log expanded normally.</li>
				<li><strong>Redirect to Log For</strong> - allows you to specify if you want go to the Mod List to be redirected to the View Log on <strong>Errors Only</strong> or for <strong>All Transactions</strong>.  The default is to redirect on <strong>Errors Only</strong> which displays the View Log only if errors are encountered in the install, uninstall, clean up, or delete transaction.</li>
				<li><strong>Log full path for file actions</strong> - allows you to select No to only display the relative path for files in the log. The default is <strong>Yes</strong> to display the full absolute path.</li>
			</ul></p>
		<p><strong>Display Settings Options</strong> 
			<ul>
				<li><strong>Sort Lists by</strong> - allows you to specify on which column to sort the Mod List.  Options are Mod Name or Config File Name.  The default is <strong>Mod Name</strong>.</li>
				<li><strong>Use Fixed Headers</strong> - allows you to change the option so that fixed headers are not displayed.  This option is not noticable if you have a large monitor and few mods.  The default is <strong>Yes</strong> to display the fixed headers.  Note that regardless of this option setting, fixed headers will not be displayed for smart phones (mobile mode).</li>
				<li><strong>Adjust Fixed Headers</strong> - allows you to enable the adjust fixed headers jQuery when the fixed headers are not displayed correctly.  This option is only needed on certain monitors.  The default is <strong>No</strong> to not use the jQuery javascript to adjust the fixed headers.</li>
				<li><strong>Use Stripes</strong> - allows you to change the option not to use stripes when displaying the Mod List.  The default is <strong>Yes</strong> which uses the databackalt class to provide alternate color striping after N number of rows.</li>
				<li><strong>Stripe after number of rows</strong> - allows you to set the number of rows to display before the alternate color stripe is displayed.  The default is <strong>3</strong> rows of databack and then 3 rows of databackalt.</li>
				<li><strong>Show Mod Warnngs in Status</strong> - allows you to turn off the syntax warning errors.  The default is <strong>Yes</strong> to display the warnings.  It is recommended that you do not change the default.</li>
				<li><strong>Compress Mod Names in Mod List</strong> - allows you the remove the blanks from the Mod Names before displaying them in the Mod Name list.  The default is <strong>No</strong> which will display the embedded blanks in the Mod Name which should match the TNG Wiki article name.</li>
				<li><strong>Show Analyzer tab</strong> - allows you to specify if you want the Mod Conflict Analyzer tab to be displayed.  The default is <strong>No</strong> which is to suppress the display of the Analyzer tab.</li>
			</ul></p>
		<p><strong>Other Options</strong> 
			<ul>
				<li><strong>Allow Delete Selected on Partially Installed Page</strong> - enables the <strong>Delete Selected</strong> button on the Partially Installed mods screen that allows deleting more than one mod at a time, such as deleting the prior versions of mods that were not deleted prior to installing the newer versions.  The default is <strong>No</strong>.  We recommend that you only enable this option when you need it to delete multiple mods without having to uninstall the current versions to delete the prior versions and that you normally leave the option set to No.</li>
				<li><strong>Allow Delete of individually Installed Mods</strong> - allows you to turn on the option to display a Delete button next to the Uninstall button for individually installed mods, such as deleting the prior version of a mod that was not deleted prior to installing the newer version.  The default is <strong>No</strong>.  We recommend that you only enable this option when you need it to delete a previous version of a mod without having to uninstall the current version in order to delete the prior version and that you normally leave the option set to No.</li>
			</ul></p>
	</td>
</tr>

<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="analyze"><p class="subheadbold">Mod Conflict Analyzer</p></a>

		<p>Created by Rick Bisbee this tool located under the <strong>Analyzer</strong> tab was previously provided as a mod. The Mod Conflict Analyzer lets developers examine mods to see precisely how they interact with each other. Two mods changing the same block of code almost always results in Mod Manager errors.  You must enable the <strong>Show Analyzer tab</strong> by setting the Options to Yes if want the Analyzer tab to be displayed.</p>

		<p>The analyzer works by examining every mod in the mods folder and cataloging which target files and which blocks of code each one modifies. It then lists the affected file names in the left hand column.  Selecting one of those target files displays a list on the right showing all the mods that change it.  Each mod shown on the right has a link to open a section of the page displaying the actual modifications made by the Mod Manager Config file. A user can compare changes to the target file to see where potential conflicts might be. </p>
		<p>This is helpful not only to find conflicts between two mods but also to know which mods need to be cleaned up and re-installed after replacing the given target file. </p>

		<p>The TNG Wiki provides additional information for the mod developers on <a href="http://tng.lythgoes.net/wiki/index.php?title=Using_the_Mod_Analyzer" target="_blank">Using the Mod Analyzer</a>.</p>
	</td>
</tr>


</table>
</body>
</html>