<?php
include("../../helplib.php");
echo help_header("Help: DNA Tests");
?>

<body class="helpbody">
<a name="top"></a>
<table width="100%" border="0" cellpadding="10" cellspacing="2" class="tblback normal">
<tr class="fieldnameback">
	<td class="tngshadow">
		<p style="float:right; text-align:right" class="smaller menu">
			<a href="http://tng.community" target="_blank" class="lightlink">TNG Forum</a> &nbsp; | &nbsp;
			<a href="http://tng.lythgoes.net/wiki" target="_blank" class="lightlink">TNG Wiki</a><br />
			<a href="reports_help.php" class="lightlink">&laquo; Help: Reports</a> &nbsp; | &nbsp;
			<a href="languages_help.php" class="lightlink">Help: Languages &raquo;</a>
		</p>
		<span class="largeheader">Help: DNA Tests</span>
		<p class="smaller menu">
			<a href="#search" class="lightlink">Search</a> &nbsp; | &nbsp;
			<a href="#add" class="lightlink">Add New</a> &nbsp; | &nbsp;
			<a href="#edit" class="lightlink">Edit Existing</a> &nbsp; | &nbsp;
			<a href="#delete" class="lightlink">Delete</a>
		</p>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<a name="search"><p class="subheadbold">Search</p></a>
        <p>Locate existing tests by searching for all or part of the <strong>Person ID</strong> or <strong>Name</strong>. Select a Tree or check one of the other options to further narrow your search.
		Searching with no options selected and no value in the search box will find all people in your database.</p>

		<p>Your search criteria for this page will be remembered until you click the <strong>Reset</strong> button, which restores all default values and searches again.</p>

		<span class="optionhead">Actions</span>
		<p>The Action buttons next to each search result allow you to edit, delete or preview that result. To delete more than one record at a time, click the box in the
		<strong>Select</strong> column for each record to be deleted, then click the "Delete Selected" button at the top of the list. Use the <strong>Select All</strong> or <strong>Clear All</strong>
		buttons to toggle all select boxes at once.</p>

	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="add"><p class="subheadbold">Adding New Tests</p></a>
		<p>To add a new test, click on the <strong>Add New</strong> tab, then fill out the form. The test can be linked to people in the database after it has been saved.</p>

		<span class="optionhead">Test Type</span>
		<p>Select the type of DNA test this record refers to.</p>

		<span class="optionhead">Test Number</span>
		<p>Enter the ID number associated with this test. If you can't find a number or the vendor didn't give you one, feel free to make up a new number.</p>

		<span class="optionhead">Test Taker</span>
		<p>This is the person who took the test. Select the tree and enter the person's ID, or click the magnifying glass to look up the individual by name.</p>

		<span class="optionhead">Vendor</span>
		<p>Enter the name of the company that supplied the test (optional).</p>

		<span class="optionhead">Number of Markers</span>
		<p>A genetic marker is a gene or DNA sequence with a known location on a chromosome that can be used to identify an individual. DNA tests can be distinguished by the number of markers they test for.
			Typical Y-DNA tests can be done for 20, 37, 44, 67, 91, 101 or 111 markers.</p>

		<span class="optionhead">Haplogroup</span>
		<p>A haplogroup is a genetic population of people who share a common ancestor on the patrilineal or matrilineal line. 
			Haplogroups are assigned letters of the alphabet (A-T), and refinements (SNPs) consist of additional number and letter combinations.</p>
		<p>An SNP (Single-nucleotide polymorphism) happens when a single place in the genome sequence is altered during the cell formation process and this mutation 
			persists in the progeny. A person has many inherited SNPs that together create a unique (UEP) DNA pattern for that individual.</p>
        <p>In genetic genealogy a unique-event polymorphism (UEP) is a genetic marker that corresponds to a mutation which is likely to occur so infrequently that it is believed overwhelmingly probable that all the individuals who share the marker, worldwide, will have inherited it from the same common ancestor, and the same single mutation event.</p>

		<span class="optionhead">Significant SNPs</span>
		<p>These SNPs could be clinically related, American Indian related, etc.</p>

		<span class="optionhead">Terminal SNP</span>
		<p>A terminal SNP is the defining SNP of the latest branch of a haplogroup known by current research. It should be unique and constant in time.</p>

		<span class="optionhead">Notes</span>
		<p>Enter any notes associated with the test, or any other information you might have.</p>

		<span class="optionhead">Relevant Links</span>
		<p>If there are web sites or pages associated with this test, enter them here. Put each link on a new line. Enter the site or page title and the URL, 
			separated by a comma. For example, "Ancestry.com,http://www.ancestry.com". If you don't include the site or page title, the link itself will be used as the title.</p>

		<p>When you are finished, click the "Save" button to return to the list.</p>

		<p>For further information, please see the following pages on the TNG Wiki:</p>
		<ul>
			<li><a href="http://tng.lythgoes.net/wiki/index.php/DNA_Tests" target="_blank">DNA Tests<a></li>
			<li><a href="http://tng.lythgoes.net/wiki/index.php/TNG_and_DNA_Tests" target="_blank">TNG and DNA Tests<a></li>
		</ul>

	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="edit"><p class="subheadbold">Editing Existing Tests</p></a>
		<p>To make changes to an existing test, use the <a href="#search">Search</a> tab to locate the test, then click on the Edit icon next to that test.</p>

		<span class="optionhead">Test Links</span>
		<p>You can link this test to individuals in your database. For each link, first select the tree associated with the link entity.
		Next, enter the ID number of the person to link, then click on the "Add" button to create the link.</p>

		<p>If you don't know the ID number, click the magnifying glass icon to search for it. A popup window will appear to let you do the searching.
		When you find the desired individual, click the person's name to add their ID to the add box, then click the "Add" button as described above.</p>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p style="float:right"><a href="#top">Top</a></p>
		<a name="delete"><p class="subheadbold">Deleting Existing Tests</p></a>
		<p>To delete a test, use the <a href="#search">Search</a> tab to locate the test, then click on the Delete icon next to that test. The row will
		change color and then vanish as the test is deleted. To delete more than one test at a time, check the box in the Select column next to each test to be
		deleted, then click the "Delete Selected" button at the top of the page.</p>

	</td>
</tr>

</table>
</body>
</html>
